;												
; EMPFNGER										
; Bernhard.Erfurt@gmx.de						
; 05/2008										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> RS232 TX								
; PB2 ==> INPUT (EMPFNGER-AUSGANG)				
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> TAKT (Testzwecke)						
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; USART							
.equ BAUD		=57600

; TIMER-WERTE					
.equ TIMERWERT0 =256-200
; FLANKE ZEITFENSTER			
.equ ZEITFENSTER_MIN = 155-20
.equ ZEITFENSTER_MAX = 155+20

; LEDS 											
.equ LED_D_GRUEN		= 5
.equ LED_D_GELB			= 6
.equ LED_D_ROT			= 7
; 433MHZ						
.equ TX_433MHZ_PORT		= PORTD
.equ TX_433MHZ_PIN		= 2

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=0x0060			; 0x0060 START Adresse 		

.equ adr_HF_SYNCHRONISATION_AKTIV	=0x0060+10
.equ adr_HF_TAKT_PEGEL				=0x0060+53
.equ adr_HF_FLANKE					=0x0060+54		; 0=fallend 1=steigend			
.equ adr_HF_FLANKE_ERKANNT			=0x0060+55		; eine gltige FLANKE erkannt	

.equ adr_BIT_WERT					=0x0060+60		; 0 oder 1				
.equ adr_BIT_NUMMER					=0x0060+61
.equ adr_DATEN_BYTE					=0x0060+62
.equ adr_DATEN_BYTE_GUELTIG			=0x0060+63

.equ adr_DATENBIT_00				=0x0060+100		; Synchronisationsbit 0	
.equ adr_DATENBIT_01				=0x0060+101		; Synchronisationsbit 1	
.equ adr_DATENBIT_02				=0x0060+102		; Synchronisationsbit 2	
.equ adr_DATENBIT_03				=0x0060+103		; DatenBit 0			
.equ adr_DATENBIT_04				=0x0060+104		; DatenBit 1			
.equ adr_DATENBIT_05				=0x0060+105		; DatenBit 2			
.equ adr_DATENBIT_06				=0x0060+106		; DatenBit 3			
.equ adr_DATENBIT_07				=0x0060+107		; DatenBit 4			
.equ adr_DATENBIT_08				=0x0060+108		; DatenBit 5			
.equ adr_DATENBIT_09				=0x0060+109		; DatenBit 6			
.equ adr_DATENBIT_10				=0x0060+110		; DatenBit 7			
; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_DATEN			= 0



; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp EXT_INT0   		; IRQ0 Handler        									
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp TIM0_OVF 			;Timer0 Overflow Handler        						
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	;USART RX Complete Handler      
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b11111111	; 
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11100000	; LEDs /RX(433MHz)/TX / RX	
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				

; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; USART_INITIALISIEREN								
	rcall USART_INITIALISIEREN	
; EXTERNER_INTERRUPT_KONFIGURIEREN					
	rcall EXTERNER_INTERRUPT_KONFIGURIEREN

; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp



; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################
	rcall wait_100ms
	cbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
	sbi PORTD,LED_D_ROT		; ROT	

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	; Watch-Dog-RESET		
	WDR		
	; wurde ein Datenbyte empfangen?
	LDS temp,(adr_DATEN_BYTE_GUELTIG)
	tst temp
	breq LOOP
;-------------------------------------------------------------------------------
	; DATEN_BYTE_GUELTIG		
	STS(adr_DATEN_BYTE_GUELTIG),NULL
	; RS232 senden				
	LDS temp,(adr_DATEN_BYTE)
	rcall SENDEN			; INP: TEMP	
	; Programm Check			
	rcall PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RXRS232_TIMER.asm"
.include "RXRS232_SONSTIGES.asm"
.include "RXRS232_INTERRUPT.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################


