; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp
	; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp   
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
; ----------------------------------
; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp     
	; TAKT-PEGEL					
	LDS temp,(adr_HF_TAKT_PEGEL)	; laden				
	com temp						; invertieren		
	STS(adr_HF_TAKT_PEGEL),temp		; speichern			
	out PORTC,temp					; an PORT ausgeben	

	rcall HF_FLANKE_FEHLERPRUEFUNG
	STS(adr_HF_FLANKE_ERKANNT),NULL
; ----------------------------------
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
HF_FLANKE_FEHLERPRUEFUNG:
	; SYNCHRONISATION aktiv ?
	LDS temp,(adr_HF_SYNCHRONISATION_AKTIV)
	tst temp
	breq HF_FLANKE_FEHLERPRUEFUNG_w
	ret
HF_FLANKE_FEHLERPRUEFUNG_w:
	LDS temp,(adr_HF_FLANKE_ERKANNT)
	tst temp
	breq HF_FLANKE_FEHLERPRUEFUNG_ERROR
	ret
HF_FLANKE_FEHLERPRUEFUNG_ERROR:
	; BIT-NUMMER NULL			
	STS(adr_BIT_NUMMER),NULL
	; SYNCHRONISATION aktivieren
	STS(adr_HF_SYNCHRONISATION_AKTIV),EINS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
