;															
; RS232 + 433MHz SENDER - TX								
; Bernhard.Erfurt@gmx.de									
; 05/2008													
;															
; Ein ber USART(RS232) empfangenes Zeichen wird ber		
; ein HF-Sendemodul (z.B. 433MHZ) bertragen.				
; Die Codierung erfolgt mit einem einfachen Manchestercode 	
; Der Sende-Puffer ist 256 BYTE gro						
;															

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> TAKT (TESTAUSGANG)					
;												
; PD0 ==> RS232-RX								
; PD1 ==> 										
; PD2 ==> HF-SENDER								
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; USART							
.equ BAUD		=57600

; TIMER-WERTE					
.equ TIMERWERT0 =256-100			
; LEDS 											
.equ LED_D_GRUEN		= 5
.equ LED_D_GELB			= 6
.equ LED_D_ROT			= 7
; 433MHZ						
.equ TX_433MHZ_PORT		= PORTD
.equ TX_433MHZ_PIN		= 2

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					= 0x0060			; 0x0060 START Adresse 		

.equ adr_DATENBYTE				= 0x0060+10 

.equ adr_HF_DATENBYTE			=0x0060+50		; Datenbyte	
.equ adr_HF_TAKT_NR				=0x0060+52		; TAKT-Nummer 0=Ruhe <>0=Senden	
.equ adr_HF_TAKT_PEGEL			=0x0060+53		; PEGEL		

.equ adr_PUFFER_ZEIGER_INPUT	=0x0060+60
.equ adr_PUFFER_ZEIGER_OUTPUT	=0x0060+61

.equ adr_PUFFER_BEREICH			=0x0060+100		; 256 BYTE fr PUFFER


; EEPROM-BELEGUNG ATmega8						
.equ adr_EEPROM_DATEN			= 0

.equ EEPROM_WERKSEINSTELLUNG	= 0


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp TIM0_OVF 			;Timer0 Overflow Handler           						
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp ZEICHEN_EINLESEN 	;USART RX Complete Handler         						
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
	cbi PORTD,LED_D_ROT		; LED ROT			
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	


; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b11111111	; Taktausgang			
	out DDRC, temp
; PORT C setzen										
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11100100	; LEDs /TX(433MHz)/TX / RX	
	out DDRD, temp
; PORT D setzen										
	out PORTD, temp				
; PIN auf LOW										
	cbi PORTD,TX_433MHZ_PIN



; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; USART_INITIALISIEREN								
	rcall USART_INITIALISIEREN	
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; 433MHZ_TAKT_PEGEL		
	STS(adr_HF_TAKT_PEGEL),NULL


; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################

	cbi PORTD,LED_D_GRUEN	; GRN	

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR						; Watch-Dog-RESET					
	rcall PUFFER_AUSLESEN	; PUFFER auslesen und ggf. senden	
	rcall PROGRAMM_CHECK	; PROGRAMM-CHECK					
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
PUFFER_AUSLESEN:
	; Zeiger PUFFER-Input laden	
	LDS temp1,(adr_PUFFER_ZEIGER_INPUT)
	; Zeiger PUFFER-OUTPUT laden
	LDS temp2,(adr_PUFFER_ZEIGER_OUTPUT)
	; sind beide Zeiger gleich ?
	cp temp1,temp2
	brne PUFFER_AUSLESEN_START
	ret
;-------------------------------------------------------------------------------
PUFFER_AUSLESEN_START:
	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_PUFFER_BEREICH)
	ldi ZH, LOW(adr_PUFFER_BEREICH)
	; Zeiger PUFFER-OUTPUT laden
	LDS temp,(adr_PUFFER_ZEIGER_OUTPUT)
	; addieren					
	add ZL,temp
	adc ZH,NULL
	; Zeichen einlesen			
	LD temp,Z
	; Zeiger PUFFER-OUTPUT +1	
	LDS temp1,(adr_PUFFER_ZEIGER_OUTPUT)
	inc temp1
	STS(adr_PUFFER_ZEIGER_OUTPUT),temp1 
	; senden					
	rcall SENDEN_HF			; INP: temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TXRS232_USART.asm"
.include "TXRS232_TIMER.asm"
.include "TXRS232_SONSTIGES.asm"


; ##############################################################################
; ##############################################################################
; ##############################################################################

