; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_INITIALISIEREN:
	ldi temp,TAKT/(BAUD*16)-1  		; Baudrate 								
	out UBRRL,temp
   	ldi temp, (1<<URSEL)|(3<<UCSZ0)	; Frame-Format: 8 Bit					
    out UCSRC, temp
    sbi UCSRB, RXCIE                ; Interrupt bei Empfang	aktivieren		
    sbi UCSRB, RXEN 				; RX aktivieren (Empfang)      			
	sbi UCSRB, TXEN  				; TX aktivieren                 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Interruptroutine wird ausgefhrt sobald ein Byte ber das UART empfangen wurde
; Das empfangene Zeichen wird im Puffer abgelegt								
ZEICHEN_EINLESEN:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push ZL
	push ZH
; -------------------------------
	; Z-ZEIGER initialisieren	
	ldi ZL, LOW(adr_PUFFER_BEREICH)
	ldi ZH, LOW(adr_PUFFER_BEREICH)
	; Zeiger PUFFER-Input laden	
	LDS temp,(adr_PUFFER_ZEIGER_INPUT)
	; addieren					
	add ZL,temp
	adc ZH,NULL
	; Zeichen einlesen			
	in temp, UDR
	; Zeichen speichern			
	ST Z,temp
	; Zeiger PUFFER INPUT +1	
	LDS temp,(adr_PUFFER_ZEIGER_INPUT)
	inc temp
	STS(adr_PUFFER_ZEIGER_INPUT),temp
; -------------------------------
	pop ZH
	pop ZL
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti              
; ##############################################################################
; ##############################################################################
; ##############################################################################
